Given an array of integers, find two numbers such that they add up to a specific target number.java
The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.app
Please note that your returned answers (both index1 and index2) are not zero-based.less
You may assume that each input would have exactly one solution.oop
Input: numbers={2, 7, 11, 15}, target=9ui
Output: index1=1, index2=2spa
Tags; Array Hash Tablerest
1 import java.util.*; 2 3 public class Solution { 4 public int[] twoSum(int[] numbers, int target) { 5 int[] index = new int[2]; 6 HashMap hm = new HashMap(); 7 int lens = numbers.length; 8 for(int i=0; i<lens; i++){ 9 Integer j = (Integer)hm.get(target-numbers[i]); 10 if(j != null){ 11 index[0] = j+1; 12 index[1] = i+1; 13 return index; 14 } 15 hm.put(numbers[i], i); 16 } 17 return index; 18 } 19 }
The brute force approach is simple. Loop through each element x and find if there is another value that equals to target – x. As finding another code
value requires looping through the rest of array, its runtime complexity is O(n2).blog
We could reduce the runtime complexity of looking up a value to O(1) using a hash map that maps a value to its index.ci